use std::io;
use std::io::BufRead;
use std::io::Write;
use std::net;
use std::thread;
use std::time;

fn main()
{
    let server_addresss : &str = "127.0.0.1:8888";

    let mut tcp_stream : net::TcpStream = net::TcpStream::connect(server_addresss).expect("서버 접속시 에러가 발생했습니다.");

    tcp_stream.set_nonblocking(true).expect("넌블로킹 모드 설정시 에러가 발생했습니다.");

    println!("서버에 접속했습니다 : {}", server_addresss);

    start_thread(tcp_stream.try_clone().unwrap());

    let user_name : String = input("사용자명을 입력해 주시기 바랍니다.");

    println!("{}님 메시지를 입력해 주시기 바랍니다.", user_name);

    loop
    {
        let message : String = input("");

        let message : String = format!("{} > {}\n", user_name, message);

        let message_byte_array : &[u8] = message.as_bytes();

        tcp_stream.write_all(message_byte_array).unwrap();
    }
}

fn start_thread(tcp_stream : net::TcpStream)
{
    let mut reader : io::BufReader<net::TcpStream> = io::BufReader::new(tcp_stream);

    thread::spawn
    (
        move ||
        {
            loop
            {
                let mut message : String = String::new();

                if let Ok(byte_count_read) = reader.read_line(&mut message)
                {
                    if byte_count_read > 0
                    {
                        println!("입력 메시지 : {}", message.trim());
                    }
                }

                thread::sleep(time::Duration::from_millis(100));
            }
        }
    );
}

fn input(display_message : &str) -> String
{
    if display_message != ""
    {
        println!("{}", display_message);
    }

    let mut input_message : String = String::new();

    io::stdin().read_line(&mut input_message).expect("메시지 입력시 에러가 발생했습니다.");

    return String::from(input_message.trim());
}